xcruder = {

	onModelChange : {},
	
	logLevel : 3, //error:0, warn:1, log:2, debug:3

	debug : function() {
		if (typeof console == 'object' && xcruder.logLevel >= 3)
			console.debug(arguments);
	},
	
	log : function() {
		if (typeof console == 'object' && xcruder.logLevel >= 2)
			console.log(arguments);
	},

	warn : function() {
		if (typeof console == 'object' && xcruder.logLevel >= 1)
			console.warn(arguments);
	},

	error : function() {
		if (typeof console == 'object' && xcruder.logLevel >= 0)
			console.error(arguments);
	},

	popup : function(content, container, bPopup) {

			if (content) {
				if (typeof content == "object")
					$(container).append(content);
				else
					$(container).html( content );
			}
			
			if (bPopup) {
				$(container).show().dialog({
					closeOnEscape:true,
					draggable:true,
					//minWidth:1000,
					//height:700,
					modal:true,
					title:'',
					position : 'top',
					dialogClass : 'xcruder-dialog',
					width : 'auto'
				});

			}
	},



/**
 * Excuting this js switches the modelClass in the main grid view
 */
	changeModelClass : function(modelClass, params) {
		//$("#modelClassSwitcher").val(modelClass).trigger("change");
		$("#modelClassSwitcher").val(modelClass);
		xcruder.onModelChange(modelClass, params);
	},
	
	
	






	onrender_relateds : function(container, resp) {
		$(container).html(resp);
	},

	onrender_form : function(container, resp) {
		xcruder.popup( resp, container, true );
	},
	onbeforesend_form : function(form) {
		//console.warn("onbeforesend_form form:",form);
		$(form).xmask({
			message : "Posting request...",
			className : "",
			timeOut : 0
		});
	},
	onsuccess_form : function(form, gridId, resp) {
		//console.warn("onsuccess_form gridId:",gridId);
		if (gridId)
			$.fn.yiiGridView.update(gridId);
		
		$(form).xmask("destroy");
		if (resp)
			$(form).parents(".form-container:first").html( resp );
	},



	validateAjaxForm : function($frm) {
		var evs = $frm.data('events');
		if (!evs || !evs.submit || !evs.submit[0] || !evs.submit[0].handler)
			return true;
		return evs.submit[0].handler();
	},

	canDeleteRelateds : function(modelRelationClass, id_grid) {
		var nrows = $("#" + id_grid + " > table > tbody > tr > td.checkbox-column").length;
		var nchecked = $("#" + id_grid + " > table > tbody td.checkbox-column > input:checked").length;
		if (!nchecked) {
			alert("No records selected!");
			return false;
		}
		
		return true;
	},
	canCreateRelated : function(modelRelationClass, id_grid) {
		var nrows = $("#" + id_grid + " > table > tbody > tr > td.checkbox-column").length;
		if ((modelRelationClass == "CHasOneRelation" || modelRelationClass == "CBelongsToRelation") && nrows > 0) {
			alert("Cannot be more than one records in this relation.");
			return false;
		}

		return true;
	},
	canSelectRelated : function(modelRelationClass, id_grid) {
		var nrows = $("#" + id_grid + " > table > tbody > tr > td.checkbox-column").length;
		if ((modelRelationClass == "CHasOneRelation" || modelRelationClass == "CBelongsToRelation") && nrows > 0) {
			alert("Cannot be more than one records in this relation.");
			return false;
		}

		return true;
	},

/**
 * Callback of an Update post
 * */
	onsuccess_update : function(resp) {

		$("#updatecontainer").xmask("option", {
			message : "Success!",
			timeOut : 500,
			className : "success"
		});
		
		var respObj = $.parseJSON(resp);

		if (respObj.modelClass) {

			var tb = $("#browsecontainer table");
			var ths = tb.find("th");
			var trs = tb.find("tr");
			
			for(var i=0;i<ths.length;i++) {
				var th = $(ths[i]);
				var colName = th.find("a").html();

				for(var key in respObj.model) 
					if (colName.toLowerCase() == key.toLowerCase()) {
						
						var td = trs[xcruder._rowIndex].cells[i];
						td.innerHTML = respObj.model[key];
						
						break;
					}
			}//i
		}
		
	}
	
};
